# Reference

<!-- DO NOT EDIT: This document was generated by Puppet Strings -->

## Table of Contents

### Functions

* [`puppetplugin::secret`](#puppetpluginsecret): Puppet function to fetch secret from 'RevBits' PAM

## Functions

### <a name="puppetpluginsecret"></a>`puppetplugin::secret`

Type: Ruby 4.x API

Puppet function to fetch secret from 'RevBits' PAM

#### Examples

##### Fetching Secret from RevBits PAM

```puppet
$secret_value = Deferred(puppetplugin::secret, ['KEY_TO_FETCH', {
  appliance_url => "https://appliance-url.com",
  api_key => Sensitive("YourAPIKey"),
}])

file { '/tmp/puppetfile': # Resource type file
  ensure => file, # Create as a file
  owner => 'root', # Ownership
  group => 'root', # Group Name
  mode => '0644', # File permissions
  content => $secret_value
}
```

#### `puppetplugin::secret(String $variable_id, Hash $options)`

Puppet function to fetch secret from 'RevBits' PAM

Returns: `Sensitive` Value of the variable.

##### Examples

###### Fetching Secret from RevBits PAM

```puppet
$secret_value = Deferred(puppetplugin::secret, ['KEY_TO_FETCH', {
  appliance_url => "https://appliance-url.com",
  api_key => Sensitive("YourAPIKey"),
}])

file { '/tmp/puppetfile': # Resource type file
  ensure => file, # Create as a file
  owner => 'root', # Ownership
  group => 'root', # Group Name
  mode => '0644', # File permissions
  content => $secret_value
}
```

##### `variable_id`

Data type: `String`

variable you want to fetch from RevBits PAM.

##### `options`

Data type: `Hash`

parameter specifying `appliance_url` and `api_key`.
- `appliance_url`: RevBits PAM instance URL.
- `api_key`: API key wrapped in `Sensitive` type.

